using System;
using System.Globalization;
using System.Windows.Data;

namespace PlayParsingException
{
    public class StringToMyDoubleConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null)
                return null;

            if (targetType == typeof(MyDouble))
            {
                if (value is MyDouble) return value;

                if(value == null) throw new ArgumentNullException("value");

                var s = value as string;
                if (s != null) return new MyDouble {Actual = double.Parse(s)};

                throw new ArgumentException("Not handled type", "value");
            }

            if (targetType == typeof (string))
            {
                if (value is string) return value;

                if (value is MyDouble) return ((MyDouble) value).Actual.ToString();

                throw new ArgumentException("Not handled type", "value");
            }

            throw new ArgumentException("TargetType not supported " + targetType, "targetType");
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Convert(value, targetType, parameter, culture);
        }
    }
}